#!/bin/sh

#create pools
python3 auto_create.py huang Huang@123 pool pool

#create uss
python3 auto_create.py huang Huang@123 uss all

sleep 60

vol_size=599147937792

ussip_list=("10.1.110.189" "10.1.110.190" "10.1.110.191" "10.1.110.192" "10.1.110.193" "10.1.110.194" "10.1.110.195" "10.1.110.196" "10.1.110.197" "10.1.110.198" "10.1.110.199" "10.1.110.200" "10.1.110.201" "10.1.110.202" "10.1.110.203" "10.1.110.204" "10.1.110.205" "10.1.110.206" "10.1.110.207" "10.1.110.208" "10.1.110.209" "10.1.110.210" "10.1.110.211" "10.1.110.212" "10.1.110.213" "10.1.110.214" "10.1.110.215" "10.1.110.216" "10.1.110.217" "10.1.110.218" "10.1.110.219" "10.1.110.220")
#create Pool
echo "start create volume"
for i in {1..8}
do
       cli_ts vol create --volname=vol$i-1 --volsize=$vol_size --poolid=$i --voltype=1
       cli_ts vol create --volname=vol$i-2 --volsize=$vol_size --poolid=$i --voltype=1
       cli_ts vol create --volname=vol$i-3 --volsize=$vol_size --poolid=$i --voltype=1
       cli_ts vol create --volname=vol$i-4 --volsize=$vol_size --poolid=$i --voltype=1
       cli_ts vol create --volname=vol$i-5 --volsize=$vol_size --poolid=$i --voltype=1
       cli_ts vol create --volname=vol$i-6 --volsize=$vol_size --poolid=$i --voltype=1
done

echo "start create subsystem"
uss_ids=&(cli_ts uss list | awk '(NR)>2 {print}' |awk -F "," '{print $1}' |awk '{print $2}')
#create subsystem
cli_ts nvmf create_subsystem  --nqn nqn.2023-08.com.sds.wds:nvmf01 --sn ETWDS0000000000001 --vendor SDS
cli_ts nvmf create_subsystem  --nqn nqn.2023-08.com.sds.wds:nvmf02 --sn ETWDS0000000000002 --vendor SDS
cli_ts nvmf create_subsystem  --nqn nqn.2023-08.com.sds.wds:nvmf03 --sn ETWDS0000000000003 --vendor SDS
cli_ts nvmf create_subsystem  --nqn nqn.2023-08.com.sds.wds:nvmf04 --sn ETWDS0000000000004 --vendor SDS

echo "start bind subsystem"
#bind subsystem uss
for ip in `echo ${ussip_list[@]}`
do
        ussid1=$(cli_ts uss list |awk '/'$ip'/{print $0}' |awk 'NR==1 {print $2}')
        ussid2=$(cli_ts uss list |awk '/'$ip'/{print $0}' |awk 'NR==2 {print $2}')
	ussid3=$(cli_ts uss list |awk '/'$ip'/{print $0}' |awk 'NR==3 {print $2}')
	ussid4=$(cli_ts uss list |awk '/'$ip'/{print $0}' |awk 'NR==4 {print $2}')
	nvmfip=$(echo $ip |awk -F "." '{print $4}')
        
	cli_ts nvmf subsystem_bind_uss  --nqn nqn.2023-08.com.sds.wds:nvmf01 --ussid ${ussid1} --ip 10.1.100.${nvmfip} --port 4421 --trtype rdma
	sleep 1
        cli_ts nvmf subsystem_bind_uss  --nqn nqn.2023-08.com.sds.wds:nvmf02 --ussid ${ussid2} --ip 10.1.100.${nvmfip} --port 4422 --trtype rdma
	sleep 1
	cli_ts nvmf subsystem_bind_uss  --nqn nqn.2023-08.com.sds.wds:nvmf03 --ussid ${ussid3} --ip 10.1.100.${nvmfip} --port 4423 --trtype rdma
	sleep 1	
	cli_ts nvmf subsystem_bind_uss  --nqn nqn.2023-08.com.sds.wds:nvmf04 --ussid ${ussid4} --ip 10.1.100.${nvmfip} --port 4424 --trtype rdma
	sleep 1
done

echo "start add vol to subsystem"
#add vol to subsystem
for poolid in `seq 1 8`
do
	if [ ${poolid} -le 4 ] 
		then 
			if [ ${poolid} -le 2 ] 
				then nvmfid=1
			else 
				nvmfid=2
			fi
	else 
		if [ ${poolid} -le 6 ]
			then nvmfid=3
		else 
			nvmfid=4
		fi
	fi
		cli_ts nvmf subsystem_add_vol  --nqn nqn.2023-08.com.sds.wds:nvmf0${nvmfid} --volname vol${poolid}-1
		cli_ts nvmf subsystem_add_vol  --nqn nqn.2023-08.com.sds.wds:nvmf0${nvmfid} --volname vol${poolid}-2
		cli_ts nvmf subsystem_add_vol  --nqn nqn.2023-08.com.sds.wds:nvmf0${nvmfid} --volname vol${poolid}-3
		cli_ts nvmf subsystem_add_vol  --nqn nqn.2023-08.com.sds.wds:nvmf0${nvmfid} --volname vol${poolid}-4
		cli_ts nvmf subsystem_add_vol  --nqn nqn.2023-08.com.sds.wds:nvmf0${nvmfid} --volname vol${poolid}-5
		cli_ts nvmf subsystem_add_vol  --nqn nqn.2023-08.com.sds.wds:nvmf0${nvmfid} --volname vol${poolid}-6
done 

